Index: issm/trunk-jpl/src/c/classes/Elements/PentaRef.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/Elements/PentaRef.cpp	(revision 15563)
+++ issm/trunk-jpl/src/c/classes/Elements/PentaRef.cpp	(revision 15564)
@@ -54,6 +54,6 @@
 
 /*Reference Element numerics*/
-/*FUNCTION PentaRef::GetBMacAyealPattyn {{{*/
-void PentaRef::GetBMacAyealPattyn(IssmDouble* B, IssmDouble* xyz_list, GaussPenta* gauss){
+/*FUNCTION PentaRef::GetBMacAyealHO {{{*/
+void PentaRef::GetBMacAyealHO(IssmDouble* B, IssmDouble* xyz_list, GaussPenta* gauss){
 	/*Compute B  matrix. B=[B1 B2 B3 B4 B5 B6] where Bi is of size 5*NDOF2. 
 	 * For node i, Bi can be expressed in the actual coordinate system
@@ -85,6 +85,6 @@
 }
 /*}}}*/
-/*FUNCTION PentaRef::GetBMacAyealStokes{{{*/
-void PentaRef::GetBMacAyealStokes(IssmDouble* B, IssmDouble* xyz_list, GaussPenta* gauss){
+/*FUNCTION PentaRef::GetBMacAyealFS{{{*/
+void PentaRef::GetBMacAyealFS(IssmDouble* B, IssmDouble* xyz_list, GaussPenta* gauss){
 	/*Compute B  matrix. B=[B1 B2 B3 B4 B5 B6] where Bi is of size 5*NDOF2. 
 	 * For node i, Bi can be expressed in the actual coordinate system
@@ -131,6 +131,6 @@
 }
 /*}}}*/
-/*FUNCTION PentaRef::GetBPattyn {{{*/
-void PentaRef::GetBPattyn(IssmDouble* B, IssmDouble* xyz_list, GaussPenta* gauss){
+/*FUNCTION PentaRef::GetBHO {{{*/
+void PentaRef::GetBHO(IssmDouble* B, IssmDouble* xyz_list, GaussPenta* gauss){
 	/*Compute B  matrix. B=[B1 B2 B3 B4 B5 B6] where Bi is of size 5*NDOF2. 
 	 * For node i, Bi can be expressed in the actual coordinate system
@@ -171,6 +171,6 @@
 }
 /*}}}*/
-/*FUNCTION PentaRef::GetBprimePattyn {{{*/
-void PentaRef::GetBprimePattyn(IssmDouble* B, IssmDouble* xyz_list, GaussPenta* gauss_coord){
+/*FUNCTION PentaRef::GetBprimeHO {{{*/
+void PentaRef::GetBprimeHO(IssmDouble* B, IssmDouble* xyz_list, GaussPenta* gauss_coord){
 	/*Compute B  prime matrix. B=[B1 B2 B3 B4 B5 B6] where Bi is of size 5*NDOF2. 
 	 * For node i, Bi can be expressed in the actual coordinate system
@@ -209,6 +209,6 @@
 }
 /*}}}*/
-/*FUNCTION PentaRef::GetBprimeMacAyealStokes{{{*/
-void PentaRef::GetBprimeMacAyealStokes(IssmDouble* Bprime, IssmDouble* xyz_list, GaussPenta* gauss){
+/*FUNCTION PentaRef::GetBprimeMacAyealFS{{{*/
+void PentaRef::GetBprimeMacAyealFS(IssmDouble* Bprime, IssmDouble* xyz_list, GaussPenta* gauss){
 	/*Compute Bprime  matrix. Bprime=[Bprime1 Bprime2 Bprime3 Bprime4 Bprime5 Bprime6] where Bprimei is of size 5*NDOF2. 
 	 * For node i, Bprimei can be expressed in the actual coordinate system
@@ -249,6 +249,6 @@
 }
 /*}}}*/
-/*FUNCTION PentaRef::GetBStokes {{{*/
-void PentaRef::GetBStokes(IssmDouble* B, IssmDouble* xyz_list, GaussPenta* gauss){
+/*FUNCTION PentaRef::GetBFS {{{*/
+void PentaRef::GetBFS(IssmDouble* B, IssmDouble* xyz_list, GaussPenta* gauss){
 
 	/*Compute B  matrix. B=[B1 B2 B3 B4 B5 B6] where Bi is of size 3*NDOF4. 
@@ -316,6 +316,6 @@
 }
 /*}}}*/
-/*FUNCTION PentaRef::GetBStokesGLS {{{*/
-void PentaRef::GetBStokesGLS(IssmDouble* B, IssmDouble* xyz_list, GaussPenta* gauss){
+/*FUNCTION PentaRef::GetBFSGLS {{{*/
+void PentaRef::GetBFSGLS(IssmDouble* B, IssmDouble* xyz_list, GaussPenta* gauss){
 
 	/*Compute B  matrix. B=[B1 B2 B3 B4 B5 B6] where Bi is of size 3*NDOF4. 
@@ -382,6 +382,6 @@
 }
 /*}}}*/
-/*FUNCTION PentaRef::GetBprimeStokes {{{*/
-void PentaRef::GetBprimeStokes(IssmDouble* B_prime, IssmDouble* xyz_list, GaussPenta* gauss){
+/*FUNCTION PentaRef::GetBprimeFS {{{*/
+void PentaRef::GetBprimeFS(IssmDouble* B_prime, IssmDouble* xyz_list, GaussPenta* gauss){
 	/*	Compute B'  matrix. B'=[B1' B2' B3' B4' B5' B6' Bb'] where Bi' is of size 3*NDOF2. 
 	 *	For node i, Bi' can be expressed in the actual coordinate system
@@ -449,6 +449,6 @@
 }
 /*}}}*/
-/*FUNCTION PentaRef::GetBprimeStokesGLS {{{*/
-void PentaRef::GetBprimeStokesGLS(IssmDouble* B_prime, IssmDouble* xyz_list, GaussPenta* gauss){
+/*FUNCTION PentaRef::GetBprimeFSGLS {{{*/
+void PentaRef::GetBprimeFSGLS(IssmDouble* B_prime, IssmDouble* xyz_list, GaussPenta* gauss){
 	/*	Compute B'  matrix. B'=[B1' B2' B3' B4' B5' B6' Bb'] where Bi' is of size 3*NDOF2. 
 	 *	For node i, Bi' can be expressed in the actual coordinate system
@@ -618,6 +618,6 @@
 }
 /*}}}*/
-/*FUNCTION PentaRef::GetBPattynFriction{{{*/
-void PentaRef::GetBPattynFriction(IssmDouble* B, GaussPenta* gauss){
+/*FUNCTION PentaRef::GetBHOFriction{{{*/
+void PentaRef::GetBHOFriction(IssmDouble* B, GaussPenta* gauss){
 	/*Compute B  matrix. B=[B1 B2 B3] where Bi is square and of size 2x2. 
 	 ** For node i, Bi can be expressed in the actual coordinate system
@@ -642,6 +642,6 @@
 } 
 /*}}}*/
-/*FUNCTION PentaRef::GetLStokes{{{*/
-void PentaRef::GetLStokes(IssmDouble* LStokes, GaussPenta* gauss){
+/*FUNCTION PentaRef::GetLFS{{{*/
+void PentaRef::GetLFS(IssmDouble* LFS, GaussPenta* gauss){
 	/* Compute L  matrix. L=[L1 L2 L3] where Li is square and of size numdof. 
 	 * For node i, Li can be expressed in the actual coordinate system
@@ -655,27 +655,27 @@
 
 	const int num_dof=4;
-	IssmDouble l1l2l3[NUMNODESP1_2d];
-
-	/*Get l1l2l3 in actual coordinate system: */
-	l1l2l3[0]=gauss->coord1*(1-gauss->coord4)/2.0;
-	l1l2l3[1]=gauss->coord2*(1-gauss->coord4)/2.0;
-	l1l2l3[2]=gauss->coord3*(1-gauss->coord4)/2.0;
-
-	/*Build LStokes: */
+	IssmDouble L1L2l3[NUMNODESP1_2d];
+
+	/*Get L1L2l3 in actual coordinate system: */
+	L1L2l3[0]=gauss->coord1*(1-gauss->coord4)/2.0;
+	L1L2l3[1]=gauss->coord2*(1-gauss->coord4)/2.0;
+	L1L2l3[2]=gauss->coord3*(1-gauss->coord4)/2.0;
+
+	/*Build LFS: */
 	for(int i=0;i<3;i++){
-		LStokes[num_dof*NUMNODESP1_2d*0+num_dof*i+0] = l1l2l3[i];
-		LStokes[num_dof*NUMNODESP1_2d*0+num_dof*i+1] = 0.;
-		LStokes[num_dof*NUMNODESP1_2d*0+num_dof*i+2] = 0.;
-		LStokes[num_dof*NUMNODESP1_2d*0+num_dof*i+3] = 0.;
-
-		LStokes[num_dof*NUMNODESP1_2d*1+num_dof*i+0] = 0.;
-		LStokes[num_dof*NUMNODESP1_2d*1+num_dof*i+1] = l1l2l3[i];
-		LStokes[num_dof*NUMNODESP1_2d*1+num_dof*i+2] = 0.;
-		LStokes[num_dof*NUMNODESP1_2d*1+num_dof*i+3] = 0.;
-	}
-}
-/*}}}*/
-/*FUNCTION PentaRef::GetLprimeStokes {{{*/
-void PentaRef::GetLprimeStokes(IssmDouble* LprimeStokes, IssmDouble* xyz_list, GaussPenta* gauss){
+		LFS[num_dof*NUMNODESP1_2d*0+num_dof*i+0] = L1L2l3[i];
+		LFS[num_dof*NUMNODESP1_2d*0+num_dof*i+1] = 0.;
+		LFS[num_dof*NUMNODESP1_2d*0+num_dof*i+2] = 0.;
+		LFS[num_dof*NUMNODESP1_2d*0+num_dof*i+3] = 0.;
+
+		LFS[num_dof*NUMNODESP1_2d*1+num_dof*i+0] = 0.;
+		LFS[num_dof*NUMNODESP1_2d*1+num_dof*i+1] = L1L2l3[i];
+		LFS[num_dof*NUMNODESP1_2d*1+num_dof*i+2] = 0.;
+		LFS[num_dof*NUMNODESP1_2d*1+num_dof*i+3] = 0.;
+	}
+}
+/*}}}*/
+/*FUNCTION PentaRef::GetLprimeFS {{{*/
+void PentaRef::GetLprimeFS(IssmDouble* LprimeFS, IssmDouble* xyz_list, GaussPenta* gauss){
 	/* Compute Lprime  matrix. Lprime=[Lp1 Lp2 Lp3] where Lpi is square and of size numdof. 
 	 * For node i, Lpi can be expressed in the actual coordinate system
@@ -715,77 +715,77 @@
 	int num_dof=4;
 
-	IssmDouble l1l2l3[NUMNODESP1_2d];
+	IssmDouble L1L2l3[NUMNODESP1_2d];
 	IssmDouble dbasis[3][NUMNODESP1];
 
-	/*Get l1l2l3 in actual coordinate system: */
-	l1l2l3[0]=gauss->coord1*(1-gauss->coord4)/2.0;
-	l1l2l3[1]=gauss->coord2*(1-gauss->coord4)/2.0;
-	l1l2l3[2]=gauss->coord3*(1-gauss->coord4)/2.0;
+	/*Get L1L2l3 in actual coordinate system: */
+	L1L2l3[0]=gauss->coord1*(1-gauss->coord4)/2.0;
+	L1L2l3[1]=gauss->coord2*(1-gauss->coord4)/2.0;
+	L1L2l3[2]=gauss->coord3*(1-gauss->coord4)/2.0;
 
 	GetNodalFunctionsP1Derivatives(&dbasis[0][0],xyz_list,gauss);
 
-	/*Build LprimeStokes: */
+	/*Build LprimeFS: */
 	for(int i=0;i<3;i++){
-		LprimeStokes[num_dof*NUMNODESP1_2d*0+num_dof*i+0]  = l1l2l3[i];
-		LprimeStokes[num_dof*NUMNODESP1_2d*0+num_dof*i+1]  = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*0+num_dof*i+2]  = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*0+num_dof*i+3]  = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*1+num_dof*i+0]  = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*1+num_dof*i+1]  = l1l2l3[i];
-		LprimeStokes[num_dof*NUMNODESP1_2d*1+num_dof*i+2]  = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*1+num_dof*i+3]  = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*2+num_dof*i+0]  = l1l2l3[i];
-		LprimeStokes[num_dof*NUMNODESP1_2d*2+num_dof*i+1]  = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*2+num_dof*i+2]  = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*2+num_dof*i+3]  = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*3+num_dof*i+0]  = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*3+num_dof*i+1]  = l1l2l3[i];
-		LprimeStokes[num_dof*NUMNODESP1_2d*3+num_dof*i+2]  = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*3+num_dof*i+3]  = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*4+num_dof*i+0]  = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*4+num_dof*i+1]  = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*4+num_dof*i+2]  = l1l2l3[i];
-		LprimeStokes[num_dof*NUMNODESP1_2d*4+num_dof*i+3]  = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*5+num_dof*i+0]  = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*5+num_dof*i+1]  = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*5+num_dof*i+2]  = l1l2l3[i];
-		LprimeStokes[num_dof*NUMNODESP1_2d*5+num_dof*i+3]  = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*6+num_dof*i+0]  = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*6+num_dof*i+1]  = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*6+num_dof*i+2]  = dbasis[2][i];
-		LprimeStokes[num_dof*NUMNODESP1_2d*6+num_dof*i+3]  = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*7+num_dof*i+0]  = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*7+num_dof*i+1]  = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*7+num_dof*i+2]  = dbasis[2][i];
-		LprimeStokes[num_dof*NUMNODESP1_2d*7+num_dof*i+3]  = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*8+num_dof*i+0]  = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*8+num_dof*i+1]  = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*8+num_dof*i+2]  = dbasis[2][i];
-		LprimeStokes[num_dof*NUMNODESP1_2d*8+num_dof*i+3]  = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*9+num_dof*i+0]  = dbasis[2][i];
-		LprimeStokes[num_dof*NUMNODESP1_2d*9+num_dof*i+1]  = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*9+num_dof*i+2]  = dbasis[0][i];
-		LprimeStokes[num_dof*NUMNODESP1_2d*9+num_dof*i+3]  = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*10+num_dof*i+0] = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*10+num_dof*i+1] = dbasis[2][i];
-		LprimeStokes[num_dof*NUMNODESP1_2d*10+num_dof*i+2] = dbasis[1][i];
-		LprimeStokes[num_dof*NUMNODESP1_2d*10+num_dof*i+3] = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*11+num_dof*i+0] = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*11+num_dof*i+1] = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*11+num_dof*i+2] = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*11+num_dof*i+3] = l1l2l3[i];
-		LprimeStokes[num_dof*NUMNODESP1_2d*12+num_dof*i+0] = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*12+num_dof*i+1] = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*12+num_dof*i+2] = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*12+num_dof*i+3] = l1l2l3[i];
-		LprimeStokes[num_dof*NUMNODESP1_2d*13+num_dof*i+0] = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*13+num_dof*i+1] = 0;
-		LprimeStokes[num_dof*NUMNODESP1_2d*13+num_dof*i+2] = 0;
-		LprimeStokes[num_dof*NUMNODESP1_2d*13+num_dof*i+3] = l1l2l3[i];
-	}
-}
-/*}}}*/
-/*FUNCTION PentaRef::GetLMacAyealStokes {{{*/
-void PentaRef::GetLMacAyealStokes(IssmDouble* LStokes, GaussPenta* gauss){
+		LprimeFS[num_dof*NUMNODESP1_2d*0+num_dof*i+0]  = L1L2l3[i];
+		LprimeFS[num_dof*NUMNODESP1_2d*0+num_dof*i+1]  = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*0+num_dof*i+2]  = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*0+num_dof*i+3]  = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*1+num_dof*i+0]  = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*1+num_dof*i+1]  = L1L2l3[i];
+		LprimeFS[num_dof*NUMNODESP1_2d*1+num_dof*i+2]  = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*1+num_dof*i+3]  = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*2+num_dof*i+0]  = L1L2l3[i];
+		LprimeFS[num_dof*NUMNODESP1_2d*2+num_dof*i+1]  = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*2+num_dof*i+2]  = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*2+num_dof*i+3]  = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*3+num_dof*i+0]  = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*3+num_dof*i+1]  = L1L2l3[i];
+		LprimeFS[num_dof*NUMNODESP1_2d*3+num_dof*i+2]  = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*3+num_dof*i+3]  = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*4+num_dof*i+0]  = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*4+num_dof*i+1]  = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*4+num_dof*i+2]  = L1L2l3[i];
+		LprimeFS[num_dof*NUMNODESP1_2d*4+num_dof*i+3]  = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*5+num_dof*i+0]  = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*5+num_dof*i+1]  = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*5+num_dof*i+2]  = L1L2l3[i];
+		LprimeFS[num_dof*NUMNODESP1_2d*5+num_dof*i+3]  = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*6+num_dof*i+0]  = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*6+num_dof*i+1]  = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*6+num_dof*i+2]  = dbasis[2][i];
+		LprimeFS[num_dof*NUMNODESP1_2d*6+num_dof*i+3]  = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*7+num_dof*i+0]  = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*7+num_dof*i+1]  = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*7+num_dof*i+2]  = dbasis[2][i];
+		LprimeFS[num_dof*NUMNODESP1_2d*7+num_dof*i+3]  = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*8+num_dof*i+0]  = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*8+num_dof*i+1]  = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*8+num_dof*i+2]  = dbasis[2][i];
+		LprimeFS[num_dof*NUMNODESP1_2d*8+num_dof*i+3]  = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*9+num_dof*i+0]  = dbasis[2][i];
+		LprimeFS[num_dof*NUMNODESP1_2d*9+num_dof*i+1]  = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*9+num_dof*i+2]  = dbasis[0][i];
+		LprimeFS[num_dof*NUMNODESP1_2d*9+num_dof*i+3]  = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*10+num_dof*i+0] = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*10+num_dof*i+1] = dbasis[2][i];
+		LprimeFS[num_dof*NUMNODESP1_2d*10+num_dof*i+2] = dbasis[1][i];
+		LprimeFS[num_dof*NUMNODESP1_2d*10+num_dof*i+3] = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*11+num_dof*i+0] = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*11+num_dof*i+1] = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*11+num_dof*i+2] = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*11+num_dof*i+3] = L1L2l3[i];
+		LprimeFS[num_dof*NUMNODESP1_2d*12+num_dof*i+0] = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*12+num_dof*i+1] = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*12+num_dof*i+2] = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*12+num_dof*i+3] = L1L2l3[i];
+		LprimeFS[num_dof*NUMNODESP1_2d*13+num_dof*i+0] = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*13+num_dof*i+1] = 0;
+		LprimeFS[num_dof*NUMNODESP1_2d*13+num_dof*i+2] = 0;
+		LprimeFS[num_dof*NUMNODESP1_2d*13+num_dof*i+3] = L1L2l3[i];
+	}
+}
+/*}}}*/
+/*FUNCTION PentaRef::GetLMacAyealFS {{{*/
+void PentaRef::GetLMacAyealFS(IssmDouble* LFS, GaussPenta* gauss){
 	/*
 	 * Compute L  matrix. L=[L1 L2 L3] where Li is square and of size numdof. 
@@ -804,34 +804,34 @@
 
 	int num_dof=2;
-	IssmDouble l1l2l3[NUMNODESP1_2d];
-
-	/*Get l1l2l3 in actual coordinate system: */
-	l1l2l3[0]=gauss->coord1*(1-gauss->coord4)/2.0;
-	l1l2l3[1]=gauss->coord2*(1-gauss->coord4)/2.0;
-	l1l2l3[2]=gauss->coord3*(1-gauss->coord4)/2.0;
-
-	/*Build LStokes: */
+	IssmDouble L1L2l3[NUMNODESP1_2d];
+
+	/*Get L1L2l3 in actual coordinate system: */
+	L1L2l3[0]=gauss->coord1*(1-gauss->coord4)/2.0;
+	L1L2l3[1]=gauss->coord2*(1-gauss->coord4)/2.0;
+	L1L2l3[2]=gauss->coord3*(1-gauss->coord4)/2.0;
+
+	/*Build LFS: */
 	for(int i=0;i<3;i++){
-		LStokes[num_dof*NUMNODESP1_2d*0+num_dof*i+0] = l1l2l3[i];
-		LStokes[num_dof*NUMNODESP1_2d*0+num_dof*i+1] = 0;
-		LStokes[num_dof*NUMNODESP1_2d*1+num_dof*i+0] = 0;
-		LStokes[num_dof*NUMNODESP1_2d*1+num_dof*i+1] = l1l2l3[i];
-		LStokes[num_dof*NUMNODESP1_2d*2+num_dof*i+0] = l1l2l3[i];
-		LStokes[num_dof*NUMNODESP1_2d*2+num_dof*i+1] = 0;
-		LStokes[num_dof*NUMNODESP1_2d*3+num_dof*i+0] = 0;
-		LStokes[num_dof*NUMNODESP1_2d*3+num_dof*i+1] = l1l2l3[i];
-		LStokes[num_dof*NUMNODESP1_2d*4+num_dof*i+0] = l1l2l3[i];
-		LStokes[num_dof*NUMNODESP1_2d*4+num_dof*i+1] = 0;
-		LStokes[num_dof*NUMNODESP1_2d*5+num_dof*i+0] = 0;
-		LStokes[num_dof*NUMNODESP1_2d*5+num_dof*i+1] = l1l2l3[i];
-		LStokes[num_dof*NUMNODESP1_2d*6+num_dof*i+0] = l1l2l3[i];
-		LStokes[num_dof*NUMNODESP1_2d*6+num_dof*i+1] = 0;
-		LStokes[num_dof*NUMNODESP1_2d*7+num_dof*i+0] = 0;
-		LStokes[num_dof*NUMNODESP1_2d*7+num_dof*i+1] = l1l2l3[i];
-	}
-}
-/*}}}*/
-/*FUNCTION PentaRef::GetLprimeMacAyealStokes {{{*/
-void PentaRef::GetLprimeMacAyealStokes(IssmDouble* LprimeStokes, IssmDouble* xyz_list, GaussPenta* gauss){
+		LFS[num_dof*NUMNODESP1_2d*0+num_dof*i+0] = L1L2l3[i];
+		LFS[num_dof*NUMNODESP1_2d*0+num_dof*i+1] = 0;
+		LFS[num_dof*NUMNODESP1_2d*1+num_dof*i+0] = 0;
+		LFS[num_dof*NUMNODESP1_2d*1+num_dof*i+1] = L1L2l3[i];
+		LFS[num_dof*NUMNODESP1_2d*2+num_dof*i+0] = L1L2l3[i];
+		LFS[num_dof*NUMNODESP1_2d*2+num_dof*i+1] = 0;
+		LFS[num_dof*NUMNODESP1_2d*3+num_dof*i+0] = 0;
+		LFS[num_dof*NUMNODESP1_2d*3+num_dof*i+1] = L1L2l3[i];
+		LFS[num_dof*NUMNODESP1_2d*4+num_dof*i+0] = L1L2l3[i];
+		LFS[num_dof*NUMNODESP1_2d*4+num_dof*i+1] = 0;
+		LFS[num_dof*NUMNODESP1_2d*5+num_dof*i+0] = 0;
+		LFS[num_dof*NUMNODESP1_2d*5+num_dof*i+1] = L1L2l3[i];
+		LFS[num_dof*NUMNODESP1_2d*6+num_dof*i+0] = L1L2l3[i];
+		LFS[num_dof*NUMNODESP1_2d*6+num_dof*i+1] = 0;
+		LFS[num_dof*NUMNODESP1_2d*7+num_dof*i+0] = 0;
+		LFS[num_dof*NUMNODESP1_2d*7+num_dof*i+1] = L1L2l3[i];
+	}
+}
+/*}}}*/
+/*FUNCTION PentaRef::GetLprimeMacAyealFS {{{*/
+void PentaRef::GetLprimeMacAyealFS(IssmDouble* LprimeFS, IssmDouble* xyz_list, GaussPenta* gauss){
 	/* Compute Lprime  matrix. Lprime=[Lp1 Lp2 Lp3] where Lpi is square and of size numdof. 
 	 * For node i, Lpi can be expressed in the actual coordinate system
@@ -848,53 +848,53 @@
 	 */
 	int num_dof=4;
-	IssmDouble l1l2l3[NUMNODESP1_2d];
+	IssmDouble L1L2l3[NUMNODESP1_2d];
 	IssmDouble dbasis[3][NUMNODESP1];
 
-	/*Get l1l2l3 in actual coordinate system: */
-	l1l2l3[0]=gauss->coord1*(1-gauss->coord4)/2.0;
-	l1l2l3[1]=gauss->coord2*(1-gauss->coord4)/2.0;
-	l1l2l3[2]=gauss->coord3*(1-gauss->coord4)/2.0;
+	/*Get L1L2l3 in actual coordinate system: */
+	L1L2l3[0]=gauss->coord1*(1-gauss->coord4)/2.0;
+	L1L2l3[1]=gauss->coord2*(1-gauss->coord4)/2.0;
+	L1L2l3[2]=gauss->coord3*(1-gauss->coord4)/2.0;
 
 	GetNodalFunctionsP1Derivatives(&dbasis[0][0],xyz_list,gauss);
 
-	/*Build LprimeStokes: */
+	/*Build LprimeFS: */
 	for(int i=0;i<3;i++){
-		LprimeStokes[num_dof*NUMNODESP1_2d*0+num_dof*i+0] = l1l2l3[i];
-		LprimeStokes[num_dof*NUMNODESP1_2d*0+num_dof*i+1] = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*0+num_dof*i+2] = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*0+num_dof*i+3] = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*1+num_dof*i+0] = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*1+num_dof*i+1] = l1l2l3[i];
-		LprimeStokes[num_dof*NUMNODESP1_2d*1+num_dof*i+2] = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*1+num_dof*i+3] = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*2+num_dof*i+0] = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*2+num_dof*i+1] = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*2+num_dof*i+2] = l1l2l3[i];
-		LprimeStokes[num_dof*NUMNODESP1_2d*2+num_dof*i+3] = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*3+num_dof*i+0] = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*3+num_dof*i+1] = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*3+num_dof*i+2] = l1l2l3[i];
-		LprimeStokes[num_dof*NUMNODESP1_2d*3+num_dof*i+3] = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*4+num_dof*i+0] = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*4+num_dof*i+1] = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*4+num_dof*i+2] = dbasis[2][i];
-		LprimeStokes[num_dof*NUMNODESP1_2d*4+num_dof*i+3] = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*5+num_dof*i+0] = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*5+num_dof*i+1] = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*5+num_dof*i+2] = dbasis[2][i];
-		LprimeStokes[num_dof*NUMNODESP1_2d*5+num_dof*i+3] = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*6+num_dof*i+0] = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*6+num_dof*i+1] = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*6+num_dof*i+2] = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*6+num_dof*i+3] = l1l2l3[i];
-		LprimeStokes[num_dof*NUMNODESP1_2d*7+num_dof*i+0] = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*7+num_dof*i+1] = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*7+num_dof*i+2] = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*7+num_dof*i+3] = l1l2l3[i];
-	}
-}
-/*}}}*/
-/*FUNCTION PentaRef::GetLStokesMacAyeal {{{*/
-void PentaRef::GetLStokesMacAyeal(IssmDouble* LStokes, GaussPenta* gauss){
+		LprimeFS[num_dof*NUMNODESP1_2d*0+num_dof*i+0] = L1L2l3[i];
+		LprimeFS[num_dof*NUMNODESP1_2d*0+num_dof*i+1] = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*0+num_dof*i+2] = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*0+num_dof*i+3] = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*1+num_dof*i+0] = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*1+num_dof*i+1] = L1L2l3[i];
+		LprimeFS[num_dof*NUMNODESP1_2d*1+num_dof*i+2] = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*1+num_dof*i+3] = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*2+num_dof*i+0] = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*2+num_dof*i+1] = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*2+num_dof*i+2] = L1L2l3[i];
+		LprimeFS[num_dof*NUMNODESP1_2d*2+num_dof*i+3] = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*3+num_dof*i+0] = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*3+num_dof*i+1] = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*3+num_dof*i+2] = L1L2l3[i];
+		LprimeFS[num_dof*NUMNODESP1_2d*3+num_dof*i+3] = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*4+num_dof*i+0] = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*4+num_dof*i+1] = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*4+num_dof*i+2] = dbasis[2][i];
+		LprimeFS[num_dof*NUMNODESP1_2d*4+num_dof*i+3] = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*5+num_dof*i+0] = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*5+num_dof*i+1] = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*5+num_dof*i+2] = dbasis[2][i];
+		LprimeFS[num_dof*NUMNODESP1_2d*5+num_dof*i+3] = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*6+num_dof*i+0] = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*6+num_dof*i+1] = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*6+num_dof*i+2] = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*6+num_dof*i+3] = L1L2l3[i];
+		LprimeFS[num_dof*NUMNODESP1_2d*7+num_dof*i+0] = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*7+num_dof*i+1] = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*7+num_dof*i+2] = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*7+num_dof*i+3] = L1L2l3[i];
+	}
+}
+/*}}}*/
+/*FUNCTION PentaRef::GetLFSMacAyeal {{{*/
+void PentaRef::GetLFSMacAyeal(IssmDouble* LFS, GaussPenta* gauss){
 	/* Compute L  matrix. L=[L1 L2 L3] where Li is square and of size numdof. 
 	 * For node i, Li can be expressed in the actual coordinate system
@@ -908,34 +908,34 @@
 
 	int num_dof=4;
-	IssmDouble l1l2l3[NUMNODESP1_2d];
-
-	/*Get l1l2l3 in actual coordinate system: */
-	l1l2l3[0]=gauss->coord1*(1-gauss->coord4)/2.0;
-	l1l2l3[1]=gauss->coord2*(1-gauss->coord4)/2.0;
-	l1l2l3[2]=gauss->coord3*(1-gauss->coord4)/2.0;
-
-	/*Build LStokes: */
+	IssmDouble L1L2l3[NUMNODESP1_2d];
+
+	/*Get L1L2l3 in actual coordinate system: */
+	L1L2l3[0]=gauss->coord1*(1-gauss->coord4)/2.0;
+	L1L2l3[1]=gauss->coord2*(1-gauss->coord4)/2.0;
+	L1L2l3[2]=gauss->coord3*(1-gauss->coord4)/2.0;
+
+	/*Build LFS: */
 	for(int i=0;i<3;i++){
-		LStokes[num_dof*NUMNODESP1_2d*0+num_dof*i+0] = l1l2l3[i];
-		LStokes[num_dof*NUMNODESP1_2d*0+num_dof*i+1] = 0.;
-		LStokes[num_dof*NUMNODESP1_2d*0+num_dof*i+2] = 0.;
-		LStokes[num_dof*NUMNODESP1_2d*0+num_dof*i+3] = 0.;
-		LStokes[num_dof*NUMNODESP1_2d*1+num_dof*i+0] = 0.;
-		LStokes[num_dof*NUMNODESP1_2d*1+num_dof*i+1] = l1l2l3[i];
-		LStokes[num_dof*NUMNODESP1_2d*1+num_dof*i+2] = 0.;
-		LStokes[num_dof*NUMNODESP1_2d*1+num_dof*i+3] = 0.;
-		LStokes[num_dof*NUMNODESP1_2d*2+num_dof*i+0] = 0.;
-		LStokes[num_dof*NUMNODESP1_2d*2+num_dof*i+1] = 0.;
-		LStokes[num_dof*NUMNODESP1_2d*2+num_dof*i+2] = l1l2l3[i];
-		LStokes[num_dof*NUMNODESP1_2d*2+num_dof*i+3] = 0.;
-		LStokes[num_dof*NUMNODESP1_2d*3+num_dof*i+0] = 0.;
-		LStokes[num_dof*NUMNODESP1_2d*3+num_dof*i+1] = 0.;
-		LStokes[num_dof*NUMNODESP1_2d*3+num_dof*i+2] = l1l2l3[i];
-		LStokes[num_dof*NUMNODESP1_2d*3+num_dof*i+3] = 0.;
-	}
-}
-/*}}}*/
-/*FUNCTION PentaRef::GetLprimeStokesMacAyeal {{{*/
-void PentaRef::GetLprimeStokesMacAyeal(IssmDouble* LprimeStokes, IssmDouble* xyz_list, GaussPenta* gauss){
+		LFS[num_dof*NUMNODESP1_2d*0+num_dof*i+0] = L1L2l3[i];
+		LFS[num_dof*NUMNODESP1_2d*0+num_dof*i+1] = 0.;
+		LFS[num_dof*NUMNODESP1_2d*0+num_dof*i+2] = 0.;
+		LFS[num_dof*NUMNODESP1_2d*0+num_dof*i+3] = 0.;
+		LFS[num_dof*NUMNODESP1_2d*1+num_dof*i+0] = 0.;
+		LFS[num_dof*NUMNODESP1_2d*1+num_dof*i+1] = L1L2l3[i];
+		LFS[num_dof*NUMNODESP1_2d*1+num_dof*i+2] = 0.;
+		LFS[num_dof*NUMNODESP1_2d*1+num_dof*i+3] = 0.;
+		LFS[num_dof*NUMNODESP1_2d*2+num_dof*i+0] = 0.;
+		LFS[num_dof*NUMNODESP1_2d*2+num_dof*i+1] = 0.;
+		LFS[num_dof*NUMNODESP1_2d*2+num_dof*i+2] = L1L2l3[i];
+		LFS[num_dof*NUMNODESP1_2d*2+num_dof*i+3] = 0.;
+		LFS[num_dof*NUMNODESP1_2d*3+num_dof*i+0] = 0.;
+		LFS[num_dof*NUMNODESP1_2d*3+num_dof*i+1] = 0.;
+		LFS[num_dof*NUMNODESP1_2d*3+num_dof*i+2] = L1L2l3[i];
+		LFS[num_dof*NUMNODESP1_2d*3+num_dof*i+3] = 0.;
+	}
+}
+/*}}}*/
+/*FUNCTION PentaRef::GetLprimeFSMacAyeal {{{*/
+void PentaRef::GetLprimeFSMacAyeal(IssmDouble* LprimeFS, IssmDouble* xyz_list, GaussPenta* gauss){
 	/* Compute Lprime  matrix. Lprime=[Lp1 Lp2 Lp3] where Lpi is square and of size numdof. 
 	 * For node i, Lpi can be expressed in the actual coordinate system
@@ -948,23 +948,23 @@
 	 */
 	int num_dof=2;
-	IssmDouble l1l2l3[NUMNODESP1_2d];
+	IssmDouble L1L2l3[NUMNODESP1_2d];
 	IssmDouble dbasis[3][NUMNODESP1];
 
-	/*Get l1l2l3 in actual coordinate system: */
-	l1l2l3[0]=gauss->coord1*(1-gauss->coord4)/2.0;
-	l1l2l3[1]=gauss->coord2*(1-gauss->coord4)/2.0;
-	l1l2l3[2]=gauss->coord3*(1-gauss->coord4)/2.0;
+	/*Get L1L2l3 in actual coordinate system: */
+	L1L2l3[0]=gauss->coord1*(1-gauss->coord4)/2.0;
+	L1L2l3[1]=gauss->coord2*(1-gauss->coord4)/2.0;
+	L1L2l3[2]=gauss->coord3*(1-gauss->coord4)/2.0;
 	GetNodalFunctionsP1Derivatives(&dbasis[0][0],xyz_list,gauss);
 
-	/*Build LprimeStokes: */
+	/*Build LprimeFS: */
 	for(int i=0;i<3;i++){
-		LprimeStokes[num_dof*NUMNODESP1_2d*0+num_dof*i+0] = l1l2l3[i];
-		LprimeStokes[num_dof*NUMNODESP1_2d*0+num_dof*i+1] = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*1+num_dof*i+0] = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*1+num_dof*i+1] = l1l2l3[i];
-		LprimeStokes[num_dof*NUMNODESP1_2d*2+num_dof*i+0] = l1l2l3[i];
-		LprimeStokes[num_dof*NUMNODESP1_2d*2+num_dof*i+1] = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*3+num_dof*i+0] = 0.;
-		LprimeStokes[num_dof*NUMNODESP1_2d*3+num_dof*i+1] = l1l2l3[i];
+		LprimeFS[num_dof*NUMNODESP1_2d*0+num_dof*i+0] = L1L2l3[i];
+		LprimeFS[num_dof*NUMNODESP1_2d*0+num_dof*i+1] = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*1+num_dof*i+0] = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*1+num_dof*i+1] = L1L2l3[i];
+		LprimeFS[num_dof*NUMNODESP1_2d*2+num_dof*i+0] = L1L2l3[i];
+		LprimeFS[num_dof*NUMNODESP1_2d*2+num_dof*i+1] = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*3+num_dof*i+0] = 0.;
+		LprimeFS[num_dof*NUMNODESP1_2d*3+num_dof*i+1] = L1L2l3[i];
 	}
 }
Index: issm/trunk-jpl/src/c/classes/Elements/PentaRef.h
===================================================================
--- issm/trunk-jpl/src/c/classes/Elements/PentaRef.h	(revision 15563)
+++ issm/trunk-jpl/src/c/classes/Elements/PentaRef.h	(revision 15564)
@@ -38,13 +38,13 @@
 		void GetSegmentJacobianDeterminant(IssmDouble*  Jdet, IssmDouble* xyz_list,GaussPenta* gauss);
 		void GetJacobianInvert(IssmDouble*  Jinv, IssmDouble* xyz_list,GaussPenta* gauss);
-		void GetBMacAyealPattyn(IssmDouble* B, IssmDouble* xyz_list, GaussPenta* gauss);
-		void GetBMacAyealStokes(IssmDouble* B, IssmDouble* xyz_list, GaussPenta* gauss);
-		void GetBPattyn(IssmDouble* B, IssmDouble* xyz_list, GaussPenta* gauss);
-		void GetBStokes(IssmDouble* B, IssmDouble* xyz_list, GaussPenta* gauss);
-		void GetBStokesGLS(IssmDouble* B, IssmDouble* xyz_list, GaussPenta* gauss);
-		void GetBprimeMacAyealStokes(IssmDouble* Bprime, IssmDouble* xyz_list, GaussPenta* gauss);
-		void GetBprimePattyn(IssmDouble* B, IssmDouble* xyz_list, GaussPenta* gauss);
-		void GetBprimeStokes(IssmDouble* B_prime, IssmDouble* xyz_list, GaussPenta* gauss);
-		void GetBprimeStokesGLS(IssmDouble* B_prime, IssmDouble* xyz_list, GaussPenta* gauss);
+		void GetBMacAyealHO(IssmDouble* B, IssmDouble* xyz_list, GaussPenta* gauss);
+		void GetBMacAyealFS(IssmDouble* B, IssmDouble* xyz_list, GaussPenta* gauss);
+		void GetBHO(IssmDouble* B, IssmDouble* xyz_list, GaussPenta* gauss);
+		void GetBFS(IssmDouble* B, IssmDouble* xyz_list, GaussPenta* gauss);
+		void GetBFSGLS(IssmDouble* B, IssmDouble* xyz_list, GaussPenta* gauss);
+		void GetBprimeMacAyealFS(IssmDouble* Bprime, IssmDouble* xyz_list, GaussPenta* gauss);
+		void GetBprimeHO(IssmDouble* B, IssmDouble* xyz_list, GaussPenta* gauss);
+		void GetBprimeFS(IssmDouble* B_prime, IssmDouble* xyz_list, GaussPenta* gauss);
+		void GetBprimeFSGLS(IssmDouble* B_prime, IssmDouble* xyz_list, GaussPenta* gauss);
 		void GetBprimeVert(IssmDouble* B, IssmDouble* xyz_list, GaussPenta* gauss);
 		void GetBAdvec(IssmDouble* B_advec, IssmDouble* xyz_list, GaussPenta* gauss);
@@ -52,11 +52,11 @@
 		void GetBVert(IssmDouble* B, IssmDouble* xyz_list, GaussPenta* gauss);
 		void GetBprimeAdvec(IssmDouble* Bprime_advec, IssmDouble* xyz_list, GaussPenta* gauss);
-		void GetBPattynFriction(IssmDouble* L, GaussPenta* gauss);
-		void GetLStokes(IssmDouble* LStokes, GaussPenta* gauss);
-		void GetLprimeStokes(IssmDouble* LprimeStokes, IssmDouble* xyz_list, GaussPenta* gauss);
-		void GetLMacAyealStokes(IssmDouble* LMacAyealStokes, GaussPenta* gauss);
-		void GetLprimeMacAyealStokes(IssmDouble* LprimeMacAyealStokes, IssmDouble* xyz_list, GaussPenta* gauss);
-		void GetLStokesMacAyeal(IssmDouble* LStokesMacAyeal, GaussPenta* gauss);
-		void GetLprimeStokesMacAyeal(IssmDouble* LprimeStokesMacAyeal, IssmDouble* xyz_list, GaussPenta* gauss);
+		void GetBHOFriction(IssmDouble* L, GaussPenta* gauss);
+		void GetLFS(IssmDouble* LFS, GaussPenta* gauss);
+		void GetLprimeFS(IssmDouble* LprimeFS, IssmDouble* xyz_list, GaussPenta* gauss);
+		void GetLMacAyealFS(IssmDouble* LMacAyealFS, GaussPenta* gauss);
+		void GetLprimeMacAyealFS(IssmDouble* LprimeMacAyealFS, IssmDouble* xyz_list, GaussPenta* gauss);
+		void GetLFSMacAyeal(IssmDouble* LFSMacAyeal, GaussPenta* gauss);
+		void GetLprimeFSMacAyeal(IssmDouble* LprimeFSMacAyeal, IssmDouble* xyz_list, GaussPenta* gauss);
 		void GetInputValue(IssmDouble* pvalue,IssmDouble* plist, GaussPenta* gauss);
 		void GetInputValue(IssmDouble* pvalue,IssmDouble* plist,GaussTria* gauss){_error_("only PentaGauss are supported");};
